#include "polygon.h"

typedef struct CONTACT_NODE {
    OBJECT_P  oA,      /* object A */
              oB;      /* object B */
    VECTOR    p, normal;
    int stable;         /* are they always stable? don't check for collision */
    int ignore;         /* should a collision check be ignored? */
    struct CONTACT_NODE *next;
} CONTACT_NODE, *CONTACT_NODE_P;

int make_contact_list( OBJ_NODE_P objs );
int find_collisions();

void check_all_on();

int contained( OBJECT_P a, VECTOR_P point );
int collide_vert( OBJECT_P a, OBJECT_P b, VECTOR_P c_point, VECTOR_P c_dir,
    double *dist );
int collide_edge( OBJECT_P a, OBJECT_P b, VECTOR_P c_point, VECTOR_P c_dir,
    double *dist );
int collide( OBJECT_P a, OBJECT_P b, VECTOR_P c_point, VECTOR_P c_dir,
    double *dist );
