#include <stdio.h>
#include "matrix.h"
#include "response.h"

void colResponse (PhysParam *o1, PhysParam *o2) {
  
  double ivec[3], jvec[3], kvec[3];  
  double equmatrix[15 * 15];
  double leqmatrix[15];
  double resmatrix[15];
  double tmpmatrix[9];
  double a, b, c;

  /* transform objects parameters to common inertial frame */

  /* find collision frames i, j, k */

  /* create equation matrix */
  
  mZero (equmatrix, 15, 15);
  mZero (leqmatrix, 15, 1);

  /* m1v1 = m1v1 + R */

  equmatrix[ 0 * 15 +  0] = o1->m[0];
  equmatrix[ 0 * 15 + 12] = -1;
  leqmatrix[0] = o1->m[0] * o1->v[0];

  equmatrix[ 1 * 15 +  1] = o1->m[1];
  equmatrix[ 1 * 15 + 13] = -1;
  leqmatrix[1] = o1->m[1] * o1->v[1];

  equmatrix[ 2 * 15 +  2] = o1->m[2];
  equmatrix[ 2 * 15 + 14] = -1;
  leqmatrix[2] = o1->m[2] * o1->v[2];

  /* m2v2 = m2v2 - R */
   
  equmatrix[ 3 * 15 +  3] = o2->m[0];
  equmatrix[ 3 * 15 + 12] = 1;
  leqmatrix[3] = o2->m[0] * o2->v[0];

  equmatrix[ 4 * 15 +  4] = o2->m[1];
  equmatrix[ 4 * 15 + 13] = 1;
  leqmatrix[4] = o2->m[1] * o2->v[1];

  equmatrix[ 5 * 15 +  5] = o2->m[2];
  equmatrix[ 5 * 15 + 14] = 1;
  leqmatrix[5] = o2->m[2] * o2->v[2];

  /* I1 w1 = I1 w1 + p1 x R */

  /* find I * w */
  mMul (tmpmatrix, o1->I, o1->w, 3, 3, 1);

  equmatrix[ 6 * 15 +  6] = o1->I[3 * 0 + 0];
  equmatrix[ 6 * 15 +  7] = o1->I[3 * 0 + 1];
  equmatrix[ 6 * 15 +  8] = o1->I[3 * 0 + 2];
  equmatrix[ 6 * 15 + 13] = o1->p[2];
  equmatrix[ 6 * 15 + 14] = -o1->p[1];
  leqmatrix[6] = tmpmatrix[0];

  equmatrix[ 7 * 15 +  6] = o1->I[3 * 1 + 0];
  equmatrix[ 7 * 15 +  7] = o1->I[3 * 1 + 1];
  equmatrix[ 7 * 15 +  8] = o1->I[3 * 1 + 2];
  equmatrix[ 7 * 15 + 12] = -o1->p[2];
  equmatrix[ 7 * 15 + 14] = o1->p[0];
  leqmatrix[7] = tmpmatrix[1];

  equmatrix[ 8 * 15 +  6] = o1->I[3 * 2 + 0];
  equmatrix[ 8 * 15 +  7] = o1->I[3 * 2 + 1];
  equmatrix[ 8 * 15 +  8] = o1->I[3 * 2 + 2];
  equmatrix[ 8 * 15 + 12] = o1->p[1];
  equmatrix[ 8 * 15 + 13] = -o1->p[0];
  leqmatrix[8] = tmpmatrix[2];

  /* I2 w2 = I2 w2 - p2 x R */

  mMul (tmpmatrix, o2->I, o2->w, 3, 3, 1);

  equmatrix[ 9 * 15 +  9] = o2->I[3 * 0 + 0];
  equmatrix[ 9 * 15 + 10] = o2->I[3 * 0 + 1];
  equmatrix[ 9 * 15 + 11] = o2->I[3 * 0 + 2];
  equmatrix[ 9 * 15 + 13] = -o2->p[2];
  equmatrix[ 9 * 15 + 14] = o2->p[1];
  leqmatrix[9] = tmpmatrix[0];

  equmatrix[10 * 15 +  9] = o2->I[3 * 1 + 0];
  equmatrix[10 * 15 + 10] = o2->I[3 * 1 + 1];
  equmatrix[10 * 15 + 11] = o2->I[3 * 1 + 2];
  equmatrix[10 * 15 + 12] = o2->p[2];
  equmatrix[10 * 15 + 14] = -o2->p[0];
  leqmatrix[10] = tmpmatrix[1];

  equmatrix[11 * 15 +  9] = o2->I[3 * 2 + 0];
  equmatrix[11 * 15 + 10] = o2->I[3 * 2 + 1];
  equmatrix[11 * 15 + 11] = o2->I[3 * 2 + 2];
  equmatrix[11 * 15 + 12] = -o2->p[1];
  equmatrix[11 * 15 + 13] = o2->p[0];
  leqmatrix[11] = tmpmatrix[2];

  /* R . i = 0 */
  equmatrix[12 * 15 + 12] = ivec[0];
  equmatrix[12 * 15 + 13] = ivec[1];
  equmatrix[12 * 15 + 14] = ivec[2];
  leqmatrix[12] = 0;

  /* R . j = 0 */
  equmatrix[13 * 15 + 12] = jvec[0];
  equmatrix[13 * 15 + 13] = jvec[1];
  equmatrix[13 * 15 + 14] = jvec[2];
  leqmatrix[13] = 0;

  /* (v2 + w2 x p2 - v1 - w1 x p1) . k = 0 */

  equmatrix[14 * 15 +  0] = - kvec[0];  
  equmatrix[14 * 15 +  1] = - kvec[1];  
  equmatrix[14 * 15 +  2] = - kvec[2];  
  equmatrix[14 * 15 +  3] = kvec[0];  
  equmatrix[14 * 15 +  4] = kvec[1];  
  equmatrix[14 * 15 +  5] = kvec[2];  
  equmatrix[14 * 15 +  6] = kvec[2] * o1->p[1] - kvec[1] * o1->p[2];
  equmatrix[14 * 15 +  7] = kvec[0] * o1->p[2] - kvec[2] * o1->p[0];
  equmatrix[14 * 15 +  8] = kvec[1] * o1->p[0] - kvec[0] * o1->p[1];
  equmatrix[14 * 15 +  9] = - kvec[2] * o2->p[1] + kvec[1] * o2->p[2];
  equmatrix[14 * 15 + 10] = - kvec[0] * o2->p[2] + kvec[2] * o2->p[0];
  equmatrix[14 * 15 + 11] = - kvec[1] * o2->p[0] + kvec[0] * o2->p[1];
  leqmatrix[14] = 0;

  mSolve (resmatrix, equmatrix, leqmatrix, 15);
  mPrintMatrix (resmatrix, 15, 1, "res");
}
